// ----------------------------------------------------------------------
// AppIconMenu - a BMenu using the app's icon
//
// Copyright © 2000 Arcane Dragon Software (arcanedragon@pobox.com)
// ----------------------------------------------------------------------

#include "AppIconMenu.h"
#include "AppIconView.h"

#include <interface/Bitmap.h>
#include <interface/Menu.h>

// ----------------------------------------------------------------------
// Constructor/destructor

AppIconMenu::AppIconMenu( BMenu *menu )
	: BMenuItem( menu ),
	  _icon( NULL )
{
	_icon = AppIconView::GetIcon( B_MINI_ICON );
}

AppIconMenu::~AppIconMenu( void )
{
	if( _icon ) delete _icon;
}

// ----------------------------------------------------------------------
// BMenuItem methods

void AppIconMenu::GetContentSize( float *width, float *height )
{
	// Use our icon's size
	BRect r = _icon->Bounds();

	*width = r.Width() + 1.0;
	*height = r.Height() + 1.0;
}

void AppIconMenu::DrawContent( void )
{
	Menu()->SetDrawingMode( B_OP_OVER );
	float w,h;
	Menu()->GetPreferredSize( &w, &h );

	BRect r = _icon->Bounds();
	BRect dest = r;
	dest.OffsetBy( 8.0, ( ( h - r.Height() ) * 0.5f ) - 1.0 );
	Menu()->DrawBitmap( _icon, r, dest );
}
