// ----------------------------------------------------------------------
// AppIconView.h - application icon view for StartUp!
//
// Copyright © 2000 Arcane Dragon Software (arcanedragon@pobox.com)
//
// The application's icon.
// ----------------------------------------------------------------------

#ifndef StartUp_AppIconView_H
#define StartUp_AppIconView_H

#include <interface/View.h>
#include <storage/Mime.h>

class BBitmap;

enum {
	APP_ICON_CLICK = 'aick',
};

class AppIconView : public BView
{
public:
	AppIconView( icon_size which = B_LARGE_ICON );
	virtual ~AppIconView( void );
	
	// BView methods to override
	virtual void Draw( BRect update );
	virtual void GetPreferredSize( float *width, float *height );
	virtual void ResizeToPreferred( void );
	virtual void MouseDown( BPoint where );

	static BBitmap *GetIcon( icon_size which = B_LARGE_ICON );

private:
	AppIconView( const AppIconView& );				// don't copy me
	AppIconView& operator=( AppIconView& );			// don't assign me

	BBitmap *_icon_bits;
	icon_size _which;
};

#endif
