// ----------------------------------------------------------------------
// ItemIconView.h - Startup Item icon view for StartUp!
//
// Copyright © 2000 Arcane Dragon Software (arcanedragon@pobox.com)
//
// The items's icon.
// ----------------------------------------------------------------------

#ifndef StartUp_ItemIconView_H
#define StartUp_ItemIconView_H

#include <interface/View.h>

class BBitmap;

class ItemIconView : public BView
{
public:
	ItemIconView( void );
	virtual ~ItemIconView( void );
	
	// BView methods to override
	virtual void Draw( BRect update );
	virtual void GetPreferredSize( float *width, float *height );
	virtual void ResizeToPreferred( void );

	// Set our icon; we don't own this.
	void SetIcon( BBitmap *icon );

private:
	ItemIconView( const ItemIconView& );				// don't copy me
	ItemIconView& operator=( ItemIconView& );			// don't assign me

	BBitmap *_icon_bits;
};

#endif
