// MD5 object - see MD5.h for details
//
// Copyright © 1998-2000 Arcane Dragon Software (arcanedragon@pobox.com)
//
// $Id$
//
// Derived from the RSA Data Security, Inc. MD5 Message-Digest Algorithm,
// RFC 1321.

#include "MD5.h"

#include <string.h>
#include <new.h>

MD5::MD5( void )
{
	MD5Init( &_context );
}

MD5::~MD5( void )
{
}

void MD5::Update( unsigned char *str )
{
	MD5Update( &_context, str, strlen( (const char *)str ) );
}

void MD5::Update( BString *str )
{
	char *ptr = str->LockBuffer( 0 );
	MD5Update( &_context, (unsigned char *)ptr, str->Length() );
	str->UnlockBuffer();
}

void MD5::Update( BString& str )
{
	char *ptr = str.LockBuffer( 0 );
	MD5Update( &_context, (unsigned char *)ptr, str.Length() );
	str.UnlockBuffer();
}

BString *MD5::Digest( void )
{
	unsigned char digested[16];

	MD5_CTX final_context = _context;
	MD5Final( digested, &final_context );

	try {
		return new BString( (char *)digested, 16 );
	} catch( bad_alloc& ex ) {
		return NULL;
	}
}
