// -*- C++ -*-
//
// MD5.h - C++ MD5 object
//
// Copyright © 1998-2000 Arcane Dragon Software (arcanedragon@pobox.com)
//
// $Id$
//
// Derived from the RSA Data Security, Inc. MD5 Message-Digest Algorithm,
// RFC 1321.

#ifndef MD5_H
#define MD5_H

#include <support/String.h>
#include "md5.h"

class MD5 {
public:
	MD5( void );
	~MD5( void );

	void Update( unsigned char *str );
	void Update( BString *str );
	void Update( BString& str );
	BString *Digest( void );	// delete this pointer when done

private:
	MD5_CTX _context;
	
	MD5( const MD5& );		// don't copy me
	MD5& operator=( MD5& );	// don't assign me
};

#endif
