// ----------------------------------------------------------------------
// StartUp! - main window
//
// Copyright © 2000 Arcane Dragon Software (arcanedragon@pobox.com)
//
// Display and manage the main interface window.
// ----------------------------------------------------------------------

#ifndef StartUp_MainWindow_H
#define StartUp_MainWindow_H

#include "MWindow.h"

class BFilePanel;
class BMessage;
class CLVContainerView;
class ColumnListView;
class MTextControl;
class MutexList;
class StartupItem;

enum {
	MAIN_EDITED_NAME		= 'meNa',
	MAIN_EDITED_ARGS		= 'meAr',
	MAIN_EDITED_DIRECTORY	= 'meDr',
//	MAIN_EDITED_WORKSPACE	= 'meWk',
	
	MAIN_MODIFIED_NAME		= 'mmNa',
	MAIN_MODIFIED_ARGS		= 'mmAr',
	MAIN_MODIFIED_DIRECTORY	= 'mmDr',
//	MAIN_MODIFIED_WORKSPACE	= 'mmWk',

	MAIN_DIRECTORY_CHOSEN	= 'm_Dc',
};

class MainWindow : public MWindow
{
public:
	MainWindow( MutexList *items );
	virtual ~MainWindow( void );

	// BWindow methods
	virtual void MessageReceived( BMessage *msg );
	virtual bool QuitRequested( void );
	
	// MainWindow methods
	void EditItem( StartupItem *item );
	void UpdateItem( StartupItem *item );

	void SelectDirectory( StartupItem *item );

private:
	MainWindow( const MainWindow& );				// don't copy me
	MainWindow& operator=( MainWindow& );			// don't assign me

	size_t _size;		// throw-away used for loading resources

	MutexList *_items;	// List of the Startup items

	// Column list view bits
	ColumnListView *_item_view;
	CLVContainerView *_item_view_scroller;

	MTextControl *_name_field;
	MTextControl *_args_field;
	MTextControl *_dir_field;

	StartupItem *_current_edit;

	BFilePanel *_directory_panel;
};
#endif
