// ----------------------------------------------------------------------
// MutexList.h
//
// Copyright © 2000 Arcane Dragon Software (arcanedragon@pobox.com)
//
// A BList that's guarded by its own mutex.  Not rocket science.
// ----------------------------------------------------------------------

#ifndef MutexList_H
#define MutexList_H

#include <support/List.h>
#include <support/SupportDefs.h>

class BLocker;

class MutexList : public BList
{
public:
	MutexList( const char *name, int count = 20 );
	virtual ~MutexList( void );
	
	// Mutex operations
	bool Lock( void );
	status_t LockWithTimeout( bigtime_t timeout );
	void Unlock( void );

	const BLocker *Mutex( void );

private:
	MutexList( const MutexList& );		// don't copy me
	MutexList& operator=( MutexList& );	// don't assign me

	BLocker *_mutex;
};

#endif
