// ----------------------------------------------------------------------
// Startup! - Nag window
//
// Copyright © 2000 Arcane Dragon Software (arcanedragon@pobox.com)
//
// Display and manage the Nag window.
// ----------------------------------------------------------------------

#ifndef StartUp_NagWindow_H
#define StartUp_NagWindow_H

#include "MWindow.h"

class BFileGameSound;
class BMessageRunner;
class MButton;

enum {
	NAG_STOP		= 'nag-',		// you can stop nagging now
	NAG_ENTER_KEY	= 'nagO',		// the user wants to register
	
	NAG_SHOW_WINDOW	= 'nag!',		// display the nag window
};

class NagWindow : public MWindow
{
public:
	NagWindow( void );
	virtual ~NagWindow( void );
	
	// BWindow methods
	virtual void MessageReceived( BMessage *msg );
	virtual bool QuitRequested( void );

private:
	NagWindow( const NagWindow& );		// don't copy me
	NagWindow& operator=( NagWindow& );	// don't assign me
	
	size_t _size;			// throwaway for loading resources
	
	BFileGameSound *_sfx;	// tick...
	BMessageRunner *_nag;	// tell me when to not nag

	MButton *_later_button;	// so we can disable it...
};

#endif
