// ----------------------------------------------------------------------
// StartUp! - Register window
//
// Copyright © 2000 Arcane Dragon Software (arcanedragon@pobox.com)
//
// Display and manage the Register window.
// ----------------------------------------------------------------------

#ifndef StartUp_RegistrationWindow_H
#define StartUp_RegistrationWindow_H

#include "MWindow.h"

#include <support/String.h>

enum {
	REG_EDITED_NAME		= 'regN',	// name field has been edited
	REG_EDITED_COMPANY	= 'regC',	// company field has been edited
	REG_EDITED_COPIES	= 'reg+',	// copies field has been edited
	REG_EDITED_KEY		= 'regO',	// key field has been edited
};

class MTextControl;

class RegistrationWindow : public MWindow
{
public:
	RegistrationWindow( void );
	virtual ~RegistrationWindow( void );

	// BWindow methods
	virtual void MessageReceived( BMessage *msg );
	virtual bool QuitRequested( void );

	void StripWhitespace( BString& str );

private:
	RegistrationWindow( const RegistrationWindow& );		// don't copy me
	RegistrationWindow& operator=( RegistrationWindow& );	// don't assign me
	
	size_t _size;		// throwaway for loading resources

	MTextControl *_name_field;
	MTextControl *_company_field;
	MTextControl *_copies_field;
	MTextControl *_key_field;

	BString _name;
	BString _company;
	BString _copies;
	BString _key;
};

#endif
