// ----------------------------------------------------------------------
// StartupSettings - StartUp!'s custom settings file
//
// Copyright © 2000 Arcane Dragon Software (arcanedragon@pobox.com)
// ----------------------------------------------------------------------

#include "StartupSettings.h"

// ----------------------------------------------------------------------
// Constructor/destructor

StartupSettings::StartupSettings( void )
	: SettingsFile( NULL )
{
}

StartupSettings::~StartupSettings( void )
{
}

// ----------------------------------------------------------------------
// StartupSettings methods

int32 StartupSettings::CheckRuns( void )
{
	// Call this once per "run"; used to extend the duration of the nag
	// screen for unregistered copies.
	int32 runs = 0;
	if( FindInt32( "runs", &runs ) != B_OK ) {
		AddInt32( "runs", runs );
	}
	
	runs++;
	(void)ReplaceInt32( "runs", runs );

	return runs;
}

void StartupSettings::SavePoint( const char *name, BPoint pos )
{
	if( ReplacePoint( name, pos ) == B_NAME_NOT_FOUND ) {
		(void)AddPoint( name, pos );
	}
}

void StartupSettings::SaveRect( const char *name, BRect rect )
{
	if( ReplaceRect( name, rect ) == B_NAME_NOT_FOUND ) {
		(void)AddRect( name, rect );
	}
}
