// ----------------------------------------------------------------------
// SysLog.h
//
// Copyright © 2000 Arcane Dragon Software (arcanedragon@pobox.com)
//
// Nicer interface to syslog, since we're using resources for all of our
// strings.
// ----------------------------------------------------------------------

#ifndef StartUp_SysLog_H
#define StartUp_SysLog_H

#include <app/Application.h>
#include <storage/Resources.h>
#include <support/SupportDefs.h>
#include <support/syslog.h>
#include <string.h>

inline char *SysLog_get( const char *name ) {
	BResources *rsrc = be_app->AppResources();
	size_t size;

	return const_cast<char *>( static_cast<const char *>( rsrc->LoadResource( B_STRING_TYPE, name, &size ) ) );
}

inline void SysLog_Open( const char *name ) {
	openlog( SysLog_get( name ), LOG_USER, LOG_PID );
}

inline void SysLog_Close( void ) {
	closelog();
}

inline void SysLog_Info( const char *name ) {
	syslog( LOG_INFO, SysLog_get( name ) );
}

inline void SysLog_Info( const char *name, const char *str ) {
	syslog( LOG_INFO, SysLog_get( name ), str );
}

inline void SysLog_Error( const char *name ) {
	syslog( LOG_ERR, SysLog_get( name ) );
}

inline void SysLog_Error( const char *name, status_t error ) {
	syslog( LOG_ERR, SysLog_get( name ), strerror( error ) );
}

inline void SysLog_Error( const char *name, const char *str ) {
	syslog( LOG_ERR, SysLog_get( name ), str );
}

#endif
