// ----------------------------------------------------------------------
// URLStringView.h
//
// Copyright © 2000 Arcane Dragon Software (arcanedragon@pobox.com)
//
// MStringView that's clickable, and launches its associated URL.
// ----------------------------------------------------------------------

#ifndef URLStringView_H
#define URLStringView_H

#include "MStringView.h"

#include <interface/Point.h>
#include <support/SupportDefs.h>

class BArchivable;
class BMessage;

class URLStringView : public MStringView
{
public:
	URLStringView( const char *label, const char *url, 
				   alignment a = B_ALIGN_LEFT,
				   minimax size = minimax( 10, 10, 65536, 65536, 1 ) );
	virtual ~URLStringView( void );

	// URL hackery
	const char *GetURL( void );
	void SetURL( const char *url );
	status_t VisitURL( void );

	// BView methods
	virtual void AttachedToWindow( void );
	virtual void MouseDown( BPoint point );

private:
	URLStringView( const URLStringView& );		// don't copy me
	URLStringView& operator=( URLStringView& );	// don't assign me

	// TODO:
	URLStringView( BMessage * );
//	virtual status_t Archive( BMessage *archive , bool deep = true ) const;
	static BArchivable *Instantiate( BMessage *archive );

	const char *_url;
};

#endif
