// Registration key generator for StartUp!.
//
// mwcc -O7 -opt schedule604 -o mk-key mk-key.cpp obj-ppc/MD5.o obj-ppc/md5c.o

#include <support/String.h>
#include <support/SupportDefs.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "MD5.h"

int main( int argc, char **argv )
{
	if( argc < 4 || ( strcmp( argv[1], "-h" ) == 0 ) ) {
		printf( "usage:\n" );
		printf( "\t%s name company copies\n", argv[0] );
		return EXIT_FAILURE;
	}

	int32 copies = atol( argv[3] );
	
	// Build MD5 digest of company, then name
	MD5 digester;
	digester.Update( (unsigned char *)argv[2] );	// company
	digester.Update( (unsigned char *)argv[1] );	// name
	if( copies == 0 ) digester.Update( (unsigned char *)argv[3] );	// copies
	BString *digest_string = digester.Digest();
	const char *digest = digest_string->String();

	// Mutate digest plus number of copies into 6 bytes...
	// Mutate digest plus number of copies into 6-byte code.
	unsigned char key[6];
	key[0] = digest[7] ^ digest[10] ^ (unsigned char)((copies & 0xff000000) >> 24);
	key[1] = digest[5] ^ digest[11] ^ digest[15];
	key[2] = digest[0] ^ digest[1] ^ digest[9] ^ digest[13] ^ digest[14];
	key[3] = digest[12];
	key[4] = digest[2] ^ digest[3] ^ digest[6] ^ (unsigned char)((copies & 0x00ff0000) >> 16) ^ (unsigned char)((copies & 0x0000ff00) >> 8);
	key[5] = digest[4] ^ digest[8] ^ (unsigned char)(copies & 0x000000ff);

	if( copies ) {
		printf( "Key for %s (%s), %ld copies:\n", argv[1], argv[2], copies );
	} else {
		printf( "Key for %s (%s), %s copies:\n", argv[1], argv[2], argv[3] );
	}
	printf( "%02x-%02x%02x-%02x%02x-%02x\n",
			key[0], key[1], key[2], key[3], key[4], key[5] );

	int32 calc = 0;
	calc += ( key[0] << 8 );
	calc += ( key[1] );
	calc += ( key[2] << 24 );
	calc += ( key[3] << 16 );
	calc ^= ( key[4] << 8 );
	calc ^= ( key[5] << 24 );

	printf( "The code is: %04lx\n", calc );

	delete digest_string;

	return EXIT_SUCCESS;
}
