#!/bin/sh
#
# Set the version and build # for StartUp! using a clever script. ;-)
#
# Copyright © 2000 Arcane Dragon Software (arcanedragon@pobox.com)

APP_NAME="StartUp"

if [ "$1" = "" ] ; then
	APP_PATH="$PWD/$APP_NAME"
else
	APP_PATH="$1"
fi

# Hard-coding the version info here is a little ugly.

VERSION_TYPE=b
VERSION_STRING="0.4.0"

# This is probably a little uglier than it could be... we'll replace it
# with something clever sometime, maybe.
MAJOR_VER=$(echo $VERSION_STRING | sed -e 's/\./ /g' | awk '{ print $1; }')
MIDDLE_VER=$(echo $VERSION_STRING | sed -e 's/\./ /g' | awk '{ print $2; }')
MINOR_VER=$(echo $VERSION_STRING | sed -e 's/\./ /g' | awk '{ print $3; }')

SHORT_VER='Easily start apps at boot time'
LONG_VER='Automatically start applications and open documents when you boot; say goodbye to that nasty UserBootscript'

# Increment the build number; note that you'll get into trouble (well, not
# really... you'll be off-by-one in the build number) if you're doing two
# builds at once and they run this script at exactly the same time.
#
# We use another attribute to keep track of the VERSION_STRING.  When it 
# changes, we reset the build_no to 0.
BUILD_VERSION_STRING=$(catattr build_version $0 2>/dev/null | awk '{ print $5; }')
if [ "$BUILD_VERSION_STRING" = "" ] || \
   [ "$BUILD_VERSION_STRING" != "$VERSION_STRING" ] ; then
	addattr build_version $VERSION_STRING $0
	addattr build_no 0 $0
fi

BUILD_NO=$(catattr build_no $0 2>/dev/null | awk '{ print $5; }')
if [ "$BUILD_NO" = "" ] ; then
	addattr build_no 0 $0
fi

NEW_BUILD_NO=$(expr $BUILD_NO + 1)
addattr build_no $NEW_BUILD_NO $0

# Whack that binary!
setversion $APP_PATH -app \
	$MAJOR_VER $MIDDLE_VER $MINOR_VER \
	$VERSION_TYPE \
	$NEW_BUILD_NO \
	-short "$SHORT_VER" \
	-long "$LONG_VER"
