#include "CommandParser.h"

#include <app/Message.h>
#include <limits.h>
#include <stdio.h>

int main( int argc, char **argv )
{
	FILE *fp = NULL;
	if( argc < 2 ) {
		fp = fopen( "/boot/home/config/boot/UserBootscript", "r" );
	} else {
		fp = fopen( argv[1], "r" );
	}
	if( !fp ) {
		fprintf( stderr, "can't open file\n" );
		return 1;
	}

	CommandParser parser;
	
	char buff[ARG_MAX];
	
	BMessage msg;
	while( fgets( buff, ARG_MAX, fp ) ) {
		printf( buff );
		status_t retval = parser.Parse( buff, msg );
		switch( retval ) {
		case B_OK:
			if( msg.HasString( "cmd" ) ) {
				printf( "Parsed that... msg is:\n" );
				msg.PrintToStream();
			} else {
				printf( "Blank line.\n" );
			}
			(void)msg.MakeEmpty();
			break;
		case B_ERROR:
			printf( "Couldn't parse that.\n" );
			(void)msg.MakeEmpty();
			break;
		case B_BUSY:
			printf( "Line was continued.\n" );
			break;
		case B_CANCELED:
			printf( "Line was a comment.\n" );
			(void)msg.MakeEmpty();
			break;
		default:
			break;
		}
	}

	fclose( fp );
	
	return 0;
}
